#include <cstdio>
#include <algorithm>
#include <cstring>
#include <cstdlib>

#define MAXN 1000000

using namespace std;

class Rook
{
	public:
	int x, y;
	int index;
	bool operator< (const Rook &a) const
	{
		if(a.x==x)
		{
			return a.y<y;
		}
		else
		{
			return a.x<x;
		}
	}
};

class Cmp
{
	public:
	bool operator() (const Rook &a, const Rook &b) const
	{
		if(a.y==b.y)
		{
			return a.x<b.x;
		}
		else
		{
			return a.y<b.y;
		}
	}
};

int N;
int nei[MAXN][4];
Rook rooks[MAXN];
char used[MAXN];

void input(void)
{
	int index;
	int M;
	
	scanf("%d", &N);
	for(index=0; index<N; ++index)
	{
		scanf("%d %d", &rooks[index].x, &rooks[index].y);	
		rooks[index].index=index;
	}
}

void buildGraph(void)
{
	int index;
	
	memset(nei, -1, sizeof nei);
	
	sort(rooks, rooks+N);
	for(index=1; index<N; ++index)
	{
		if(rooks[index].x == rooks[index-1].x)
		{
			nei[rooks[index].index][0]=rooks[index-1].index;
			nei[rooks[index-1].index][1]=rooks[index].index;
		}
	}
	
	sort(rooks, rooks+N, Cmp());
	for(index=1; index<N; ++index)
	{
		if(rooks[index].y == rooks[index-1].y)
		{
			nei[rooks[index].index][2]=rooks[index-1].index;
			nei[rooks[index-1].index][3]=rooks[index].index;
		}
	}
}

void dfs(int root)
{
	int index;
	
	used[root]=1;
	for(index=0; index<4; ++index)
	{
		if(nei[root][index] != -1 && !used[nei[root][index]])
		{
			dfs(nei[root][index]);
		}
	}
}

int calc(void)
{
	int index;
	int count=0;
	
	memset(used, 0, sizeof used);
	
	for(index=0; index<N; ++index)
	{
		if(!used[index])
		{
			dfs(index);
			++count;
		}
	}
	
	return N+count-2;
}

int main(void)
{
	input();
	buildGraph();
	printf("%d\n", calc());
	//system("pause");
	return 0;
}
